#ifndef SQLHELPER_H
#define SQLHELPER_H

#include <QObject>
#include <QtSql>
#include <QSqlTableModel>
class SqlHelper : public QObject
{
public:
    SqlHelper(QString table,QObject * parent=0);

    bool insertRecord(QSqlRecord record);
    bool deleteRecord(int modelId);
    bool deleteRecord(QString condition);
    bool updateRecord(QSqlRecord record);
    QSqlRecord record(int modelId);
    QSqlRecord emptyRecord();
    int lastInsertId();
    bool saveRecord(QSqlRecord record);


    //static fonction
    static bool insertRecord(QString table, QSqlRecord record);
    static bool deleteRecord(QString table, int modelId);
    static bool deleteRecord(QString table, QString condition);
    static bool updateRecord(QString table, QSqlRecord record);
    static QSqlRecord record(QString table, int modelId);
    static QSqlRecord emptyRecord(QString table);
    static int lastInsertId(QString table);
    static bool saveRecord(QString table, QSqlRecord record);


private:
    QString mTable;

};

#endif // SQLHELPER_H
