#include "searchdock.h"
#include <QVBoxLayout>
#include <QSqlQuery>
#include <QSqlRecord>
#include <QDebug>
SearchDock::SearchDock(QWidget *parent) :
        QDockWidget(parent)
{

    mSearchEdit = new QLineEdit;
    mSearchButton= new QPushButton(QIcon(":/icons/search.png"),"chercher");
    mTreeWidget= new QTreeWidget;
    mProgressBar = new QProgressBar;
    mInfoLabel  =new QLabel;
    mProgressBar->setTextVisible(true);
    mInfoLabel->setMargin(0);
    mTreeWidget->setColumnCount(2);

    QHBoxLayout * searchLayout = new QHBoxLayout;
    QVBoxLayout * mainLayout = new QVBoxLayout;

    searchLayout->addWidget(mSearchEdit);
    searchLayout->addWidget(mSearchButton);

    mainLayout->addLayout(searchLayout);
    mainLayout->addWidget(mProgressBar);
    mainLayout->addWidget(mProgressBar);
    mainLayout->addWidget(mInfoLabel);
    mainLayout->addWidget(mTreeWidget);
    QWidget * mainWidget = new QWidget;
    mainWidget->setLayout(mainLayout);
    setWidget(mainWidget);

    connect(mSearchButton,SIGNAL(clicked()),this,SLOT(search()));
}
void SearchDock::search()
{
    mInfoLabel->setText("Recherche...");
    QString filter = mSearchEdit->text();
    double percent = 0;
    double step = 0;
    mTreeWidget->clear();

    QTreeWidgetItem * promoteurItem = new QTreeWidgetItem;
    QTreeWidgetItem * protocoleItem = new QTreeWidgetItem;
    QTreeWidgetItem * centreItem = new QTreeWidgetItem;
    QTreeWidgetItem * etablissementItem = new QTreeWidgetItem;

    promoteurItem->setIcon(0,QIcon(":icons/promoteur.png"));
    protocoleItem->setIcon(0,QIcon(":icons/protocole.png"));
    centreItem->setIcon(0,QIcon(":icons/centre.png"));
    etablissementItem->setIcon(0,QIcon(":icons/etablissement.png"));

    promoteurItem->setText(0,"promoteur");
    protocoleItem->setText(0,"protocole");
    centreItem->setText(0,"centre");
    etablissementItem->setText(0,"etablissement");

    mTreeWidget->addTopLevelItem(promoteurItem);
    mTreeWidget->addTopLevelItem(protocoleItem);
    mTreeWidget->addTopLevelItem(centreItem);
    mTreeWidget->addTopLevelItem(etablissementItem);
 QSqlQuery query;
    //===================================================================================

   query.exec("select id, nom from promoteurs where nom LIKE '"+filter+"%'");
   if (!query.size()) {percent+=25; mProgressBar->setValue(percent);}
   else
       step =25/ (double)(query.size());
   mInfoLabel->setText("Recherche des promoteurs...");
    while ( query.next())
    {
        QTreeWidgetItem * item = new QTreeWidgetItem;
        item->setText(0,query.record().value("nom").toString());
        item->setData(0,Qt::UserRole,query.record().value("id").toString());
        item->setIcon(0,QIcon(":icons/promoteur.png"));

        promoteurItem->addChild(item);
        percent+=step;
        mProgressBar->setValue(percent);

    }
      query.finish();
//===================================================================================
    query.exec("select id, numero from centres where numero LIKE '%"+filter+"%'");
    if (!query.size()) {percent+=25; mProgressBar->setValue(percent);}
    else
        step = 25/ (double)(query.size());
       mInfoLabel->setText("Recherche des centres...");
    while ( query.next())
    {
        QTreeWidgetItem * item = new QTreeWidgetItem;
        item->setText(0,query.record().value("numero").toString());
        item->setData(0,Qt::UserRole,query.record().value("id").toString());
        item->setIcon(0,QIcon(":icons/centre.png"));
        centreItem->addChild(item);
        percent+=step;
        mProgressBar->setValue(percent);
    }
       query.finish();
    //===================================================================================
    query.exec("select id, nom from protocoles where nom LIKE '%"+filter+"%'");
    if (!query.size()) {percent+=25; mProgressBar->setValue(percent);}
    else
        step = 25/ (double)(query.size());
       mInfoLabel->setText("Recherche des protocoles...");
  while ( query.next())
    {

        QTreeWidgetItem * item = new QTreeWidgetItem;
        item->setText(0,query.record().value("nom").toString());
        item->setData(0,Qt::UserRole,query.record().value("id").toString());
        item->setIcon(0,QIcon(":icons/protocole.png"));
        protocoleItem->addChild(item);
        percent+=step;
        mProgressBar->setValue(percent);

    }
 query.finish();
  //===================================================================================
    query.exec("select id, nom from etablissements where nom LIKE '%"+filter+"%'");
    if (!query.size()) {percent+=25; mProgressBar->setValue(percent);}
    else
        step =25/ (double)(query.size());
       mInfoLabel->setText("Recherche des etablissements...");
    while ( query.next())
    {
        QTreeWidgetItem * item = new QTreeWidgetItem;
        item->setText(0,query.record().value("nom").toString());
        item->setData(0,Qt::UserRole,query.record().value("id").toString());
        item->setIcon(0,QIcon(":icons/etablissement.png"));
        etablissementItem->addChild(item);
        percent+=step;
        mProgressBar->setValue(percent);
    }
 query.finish();
  mProgressBar->setValue(percent);
mInfoLabel->setText("Recherche terminé");


    promoteurItem->setText(1,QString::number(promoteurItem->childCount())+" item(s) trouv(s)");
    protocoleItem->setText(1,QString::number(protocoleItem->childCount())+" item(s) trouv(s)");
    centreItem->setText(1,QString::number(centreItem->childCount())+" item(s) trouv(s)");
    etablissementItem->setText(1,QString::number(etablissementItem->childCount())+" item(s) trouv(s)");

}
